#include <iostream>
using namespace std;

class Name {

public:
	explicit Name (string name = "default"s) : name{move(name)} {
		cout << "Name() ..." << endl;
	}
	~Name () { cout << "~Name() ..." << endl; }
	[[nodiscard]]
	string get_name() const { return name; }

private:
	string name;
};

class Point {

public:
	explicit Point(double x = 0, double y = 0) : x{x}, y{y} {
		cout << "Point()" << endl;
	}
	~Point() { cout << "~Point()" << endl; }
	void print() const {
		cout << "(" << x << ", " << y << ")" << endl;
	}

private:
	double x, y;
};

class NamedPoint : public Point {

public:
	NamedPoint(double x, double y, string name) :
			Point(x, y), name{move(name)} {
		cout << "NamedPoint()" << endl;
	}

	NamedPoint(double x, double y) : Point(x, y) {
//	equivalent to
//	NamedPoint (double x, double y) : Point(x, y), name(Name()) {
//	so we must have default constructor in Name class
		cout << "NamedPoint()" << endl;
	}

	NamedPoint() {
//	equivalent to 
//	NamedPoint () : Point(), name(Name()) {
//	so we must have default constructor in Point class and in Name class
		cout << "NamedPoint() ..." << endl;
	}
	~NamedPoint () {
		cout << "~NamedPoint() ..." << endl;
	}
	void print () {
		cout << name.get_name() << ": ";
		Point::print();
	}

private:
	Name name;
};

int main () {
	NamedPoint().print();
	cout << endl;
	NamedPoint(1, 3).print();
	cout << endl;
	NamedPoint(3, 5, "Point"s).print();
	return 0;
}

