#include <iostream>
using namespace std;

class Point {

public:
	explicit Point(double x = 0, double y = 0) : x{x}, y{y} {}
	void print() const {
		cout << "(" << x << ", " << y << ")\n";
	}

private:
	double x, y;
};

class NamedPoint : public Point {
	string name;
public:
	NamedPoint(double x, double y, string name = "") : Point(x, y), name{move(name)} {}
	void print_name() const {
		cout << name << ": ";
	}
};

void print(const Point &p) {
	p.print();
}

int main() {
	Point point(1, 2) ;
	print(point);

	NamedPoint named_point(3, 4, "NamedPoint") ;
	named_point.print_name();
	print(named_point);	//	implicit conversion NamedPoint& -> Point&
	return 0;
}

