#include <iostream>
using namespace std;

class Point1D {
protected:
	int x{};
public:
	void set_x (int x = 0) { this->x = x; }
	[[nodiscard]] int get_x() const { return x; }
};

//	'protected' inheritance:
//	'public' & 'protected' members are 'protected' in derived class

class Point2D : protected Point1D {
	int y{};
public:
	void set (int m, int n) { 
		x = m;
		y = n; 
	}
	[[nodiscard]] int get_y() const { return y; }
	int distance () { return x * x + y * y; }
};

int main () {
	Point2D p2;
//	p2.set_x(4);	//	ERROR : set_x() protected to derived class
	p2.set(1, 2);
//	cout << "x = " << p2.get_x() << endl;	//	ERROR : get_x() protected to derived class
	cout << "y = " << p2.get_y() << endl;
	cout << "distance = " << p2.distance() << endl;
	cout << endl;
	return 0;
}

